; Created by Teasy <TheChange@yahoo.com>

; MISCELLANEOUS

AppTitle "Docking in space"

Local windowmode = UserSelectWindowMode()

Global MilliSecs = MilliSecs()
SeedRnd MilliSecs

Include "lib\string.lib.bb"
Include "lib\render.lib.bb"
Include "lib\input.def.bb"
Include "lib\math.lib.bb"
Include "lib\vcl 2a4.BB"
Include "lib\timersystem 4.bb"
Include "lib\windowhandling.bb"

; GRAPHICS

Const sx = 320
Const sy = 240
Graphics sx,sy , 32,windowmode

; maximize window
If windowmode = 3
    api_ShowWindow SystemProperty( "AppHWND" ) , SW_MAXIMIZE
End If

TFormFilter False
SetBuffer BackBuffer()
small = LoadFont( "Small Fonts" , 10 )
medium = LoadFont( "Small Fonts" , 11 )

Include "lib\maskfade.lib.bb"
MaskFade_Duration 500

; BACKGROUND

back = loadimg( "back large.png" , 320*4,240*4 , 1 )
backx# = 0
backy# = 0

Include "stars.bb"  ; self-inits

; INTERFACE

camx# = 0   ; current location
camy# = 0
camtx# = 0  ; target location
camty# = 0
camvx# = 0
camvy# = 0
camsmooth# = 0.05   ; catching up with target
camslowdown# = 0.9  ; slowing down speed when losing focus

messagebia# = 1.5       ; message brightness increase amount
messagebi# = messagebia ; message brightness increase
messageb# = messagebi   ; message brightness
messagestate = 1        ; current message

frames = 0
fps = 0
fpstimer = NewTimer( 1000 )

loframelimiter = CreateTimer( 30 )
hiframelimiter = CreateTimer( 60 )
gameturbo = False 
fpsd = 30

blinktimer = NewTimer( 300 )

; HOST SHIP

hostw = 13*16
hosth = 9*16
host = loadimg( "host1d2.png" , hostw,hosth , 9 )
MaskImage host , 0,0,0

hostrender1 = CreateImage( hostw,hosth )    ; background (prerender)
MaskImage hostrender1 , 80,0,160

hostrender2 = CreateImage( hostw,hosth )    ; background (final)
MaskImage hostrender2 , 0,0,0

hostrender3 = CreateImage( hostw,hosth )    ; foreground (mask fade)
MaskImage hostrender3 , 0,0,0

doorw = 1*16
doorh = 3*16
door = loadimg( "host1doors.png" , doorw,doorh , 3 )
MaskImage door , 80,0,160

hostpattern = loadimg( "host1pattern.png" , 16,16 , 1 )
hostpaty# = 0
hostpatyia# = .15

door1ox = 11-3      ; image offset
door1oy = 54-6
door2ox = 187-3
door2oy = door1oy

door1y = 0
door2y = 0
doorhvis = 32

doorsopen = False
doorsclosed = True 
doorsmoving = False
doorsdir = 0

hostout = True          ; hide inside of host ship
washostout = hostout    ; was previous hidden (used for maskfade switch)

hostx = -hostw/2    ; location
hosty = -hosth/2

hostproxmodel.vectormodel = createvectormodel( source_imagehandle,host , 0,0 , 80,0,160 , 1,True , 3 )
DebugLog "Host proximity: "+countvectormodelpoints( hostproxmodel )+" points"
hostcoltopmodel.vectormodel = createvectormodel( source_imagehandle,host , 0,0 , 80,0,160 , 1,True , 6 )
DebugLog "Host collision top: "+countvectormodelpoints( hostcoltopmodel )+" points"
hostcolbotmodel.vectormodel = createvectormodel( source_imagehandle,host , 0,0 , 80,0,160 , 1,True , 7 )
DebugLog "Host collision bottom: "+countvectormodelpoints( hostcolbotmodel )+" points"
hostdocktopmodel.vectormodel = createvectormodel( source_imagehandle,host , 0,0 , 80,0,160 , 1,True , 4 )
DebugLog "Host dock top: "+countvectormodelpoints( hostdocktopmodel )+" points"
hostdockbotmodel.vectormodel = createvectormodel( source_imagehandle,host , 0,0 , 80,0,160 , 1,True , 5 )
DebugLog "Host dock bottom: "+countvectormodelpoints( hostdockbotmodel )+" points"

doorcolmodel.vectormodel = createvectormodel( source_imagehandle,door , 0,0 , 80,0,160 , 1,True , 2 )
DebugLog "Door collision: "+countvectormodelpoints( doorcolmodel )+" points"

hostcamrota# = 0        ; current camera rotation (when docked)
hostcamrotaia# = 2      ; camera rotation increment amount
hostcamrotad# = 0       ; current camera rotation distance (when docked)
hostcamrotadia# = 0.005 ; camera rotation distance increment amount

; PLAYER SHIP

shipw = 32
ship = loadimg( "ship3.png" , shipw,shipw , 3 )
MaskImage ship , 80,0,160
firehi = loadimg( "ship2thrust.png" , 8,16 , 7 )
MaskImage firehi , 80,0,160
firelo = loadimg( "ship3thrust.png" , 8,16 , 7 )
MaskImage firelo , 80,0,160
rfire = loadimg( "ship3thrust2.png" , 8,8 , 5 )
MaskImage rfire , 80,0,160
shiprender = -1     ; prerendered image

shipfire1ox = 8     ; image offset: thruster left
shipfire1oy = 24
shipfire2ox = 16    ; image offset: thruster right
shipfire2oy = shipfire1oy
shipfire3ox = 12    ; image offset: reverse thruster center
shipfire3oy = 16-6

shipxs# = 0         ; starting location
shipys# = sy*3/4
shipx# = shipxs     ; current location
shipy# = shipys

shipvx# = 0         ; velocity vector x
shipvy# = 0         ; velocity vector y

shiph# = 0          ; heading
shipv# = 0          ; velocity
shipvi# = 0         ; velocity increment
shipvia# = .01      ; velocity increment amount
shipvmax# = 3       ; velocity max

shipangle# = 0      ; angle
shipanglev# = 0     ; angle velocity
shipanglevi# = 0    ; angle velocity increment
shipanglevia# = .4  ; angle velocity increment amount
shipanglevmax# = 4  ; angle velocity max

shiprvi# = 0        ; reverse velocity increment
shiprvia# = .003    ; reverse velocity increment amount

fire1frame = 0      ; current animation frames
fire2frame = 0
fire3frame = 0
fire1 = False       ; animation enabled: left thruster
fire2 = False       ; right thruster
fire3 = False       ; reverse thruster

fire1timer = NewTimer( 45 ) ; thrust animation timing (45 ms per frame)
fire2timer = NewTimer( 45 )
fire3timer = NewTimer( 45 )

turbo = False       ; thrust throttle

shipmodel.vectormodel = createvectormodel( source_imagehandle,ship , -1,-1 , 80,0,160 , 1,True , 2 )
DebugLog "Ship: "+countvectormodelpoints( shipmodel )+" points"
shipdockmodel.vectormodel = createvectormodel( source_imagehandle,ship , -1,-1 , 80,0,160 , 1,True , 1 )
DebugLog "Ship dock: "+countvectormodelpoints( shipdockmodel )+" points"

candock = False     ; collides with dock bay hook
dockvmax# = 0.2     ; dock velocity maximum
dockrotavia# = 1.5  ; dock rotation velocity increment amount

; EXPLOSIONS

shipexplode = loadimg( "ship3explode1.png" , 32,32 , 9 )
MaskImage shipexplode , 80,0,160
MidHandle shipexplode

dead = True         ; ship destroyed
explodeframe = -1
explodetimer = NewTimer( 80 )

shipshrapnel = loadimg( "ship3explode2b.png" , 64,64 , 5 )
MaskImage shipshrapnel , 80,0,160
MidHandle shipshrapnel

shrapnelframe = -1
shrapneltimer = NewTimer( 80 )

explodeimage = -1   ; prerendered image

respawning = True 
respawnpos# = 0

; MAIN LOOP

x = 0
y = 0
w = 0
h = 0
sw = 0 

Repeat
    ; input & logic

    ; TIMING

    If TimerDone( blinktimer )
        blink = Not blink
    EndIf 
    MilliSecs = MilliSecs()

    ; BACKGROUND

    ; background
    backx = backx - shipvx/16
    backy = backy - shipvy/16
    ; stars
    starfield_move -shipvx/2,-shipvy/2

    ; HOST SHIP

    ; pattern
    hostpaty = hostpaty + hostpatyia
    ; dock doors
    If doorsmoving
        door1y = door1y - doorsdir
        door2y = door2y + doorsdir
        If door1y <= -doorhvis
            doorsopen = True
            doorsclosed = False 
            doorsmoving = False
            doorsdir = 0
            door1y = -doorhvis
            door2y = doorhvis
        ElseIf door1y >= 0
            doorsopen = False
            doorsclosed = True 
            doorsmoving = False
            doorsdir = 0
            door1y = 0
            door2y = 0
        Else 
            doorsopen = False 
            doorsclosed = False 
        EndIf
    EndIf
    ; camera orbit
    If docked
        hostcamrota = hostcamrota + hostcamrotaia
        If hostcamrota >= 360
            hostcamrota = hostcamrota - 360
        ElseIf hostcamrota < 0
            hostcamrota = hostcamrota + 360
        EndIf 
        If hostcamrotad < 1
            hostcamrotad = hostcamrotad + hostcamrotadia
            If hostcamrotad > 1
                hostcamrotad = 1
            EndIf 
        EndIf 
    EndIf 
    ; dithered overlay
    MaskFade_Update

    ; PLAYER SHIP

    ; self-destruct
    If KeyHit( key_delete )
        If (Not dead) And (Not docked)
            Gosub shipexplode
        EndIf
    EndIf
    If KeyHit( key_enter )
        If Not dead
            If Not docked
                ; dock
                If candock And shipv <= dockvmax
                    docked = True
                    shipvx = 0
                    shipvy = 0
                    shipv = 0
                    shiph = 0
                    shipanglev = 0
                    messagestate = 3
                    Gosub closedoors
                    turbo = False 
                    hostcamrotad = 0
                EndIf
            Else  ; docked
                ; release
                docked = False
                messagestate = 6
                Gosub opendoors
            EndIf
        Else  ; dead
            If Not respawning
                ; respawn
                shipx = shipxs
                shipy = shipys
                shipvx = 0
                shipvy = 0
                shipv = 0
                shiph = 0
                shipangle = 0
                shipanglev = 0
                messagestate = 1
                respawning = True 
                respawnpos = 0
            EndIf 
        EndIf
    EndIf
    ; thrust
    shipvi = 0
    fire1 = False
    fire2 = False
    shiprvi = 0
    fire3 = False
    If KeyHit( key_leftshift ) Or KeyHit( key_rightshift )
        If (Not dead) And (Not docked)
            turbo = Not turbo
        EndIf
    EndIf 
    If (Not dead) And (Not docked)
        If KeyDown( key_up )
            If turbo
                shipvi = shipvia * 3
            Else
                shipvi = shipvia
            EndIf
            fire1 = True
            fire2 = True
        EndIf
        If KeyDown( key_down )
            shiprvi = shiprvia
            fire3 = True
        EndIf
    EndIf
    ; rotation
    shipanglevi = 0
    If (Not dead) And (Not docked)
        If KeyDown( key_left ) And KeyDown( key_right )
            shipvi = shipvia
            fire1 = True 
            fire2 = True 
        ElseIf KeyDown( key_left )
            shipanglevi = shipanglevi - shipanglevia
            fire2 = True
        ElseIf KeyDown( key_right )
            shipanglevi = shipanglevi + shipanglevia
            fire1 = True
        EndIf
        If shipanglevi <> 0
            shipanglev = shipanglev + shipanglevi
            If Abs( shipanglev ) > shipanglevmax
                shipanglev = Sgn( shipanglev ) * shipanglevmax
            EndIf
        Else
            shipanglev = shipanglev - Sgn( shipanglev ) * shipanglevia
            If Abs( shipanglev ) < shipanglevia
                shipanglev = 0
            Else
                If Sgn( shipanglev ) < 0
                    fire1 = True
                Else
                    fire2 = True
                EndIf
            EndIf
        EndIf
        shipangle = shipangle + shipanglev
        If shipangle < 0
            shipangle = shipangle + 360
        ElseIf shipangle >= 360
            shipangle = shipangle - 360
        EndIf
    ; rotate on dock
    ElseIf (Not dead) And docked
        If shipy < hosty+hosth/2
            ; pointing down (top dock bays)
            If Int shipangle <> 180
                If Int shipangle > 180
                    shipangle = Int shipangle - dockrotavia
                ElseIf Int shipangle <= 180
                    shipangle = Int shipangle + dockrotavia
                EndIf
                If shipangle < 0
                    shipangle = shipangle + 360
                ElseIf shipangle >= 360
                    shipangle = shipangle - 360
                ElseIf shipangle > 179 And shipangle < 181
                    shipangle = 180
                EndIf
            EndIf
        Else
            ; pointing up (bottom dock bays)
            If Int shipangle <> 0 And Int shipangle <> 360
                If shipangle > 180
                    shipangle = shipangle + dockrotavia
                ElseIf shipangle <= 180
                    shipangle = shipangle - dockrotavia
                EndIf
                If shipangle < 0
                    shipangle = 0
                ElseIf shipangle >= 360
                    shipangle = 360
                EndIf
            EndIf
        EndIf
    EndIf
    ; velocity
    If (Not dead) And (Not docked)
        shipvx = vx( shipv,shiph )
        shipvy = vy( shipv,shiph )
        If shipvi <> 0
            shipvx = shipvx + vx( shipvi,shipangle )
            shipvy = shipvy + vy( shipvi,shipangle )
        EndIf
        If shiprvi <> 0
            shipvx = shipvx + vx( shiprvi,shipangle-180 )
            shipvy = shipvy + vy( shiprvi,shipangle-180 )
        EndIf
        shipx = shipx + shipvx
        shipy = shipy + shipvy
        shipv = vd( shipvx,shipvy )
        shiph = va( shipvx,shipvy )
    ElseIf dead
        camtx = camtx - shipvx
        camty = camty - shipvy
        shipv = shipv * camslowdown
        shipvx = vx( shipv,shiph )
        shipvy = vy( shipv,shiph )
    EndIf
    ; world
    If shipx < -sx
        shipx = shipx + sx*2
        camx = camx - sx*2
    ElseIf shipx >= sx
        shipx = shipx - sx*2
        camx = camx + sx*2
    EndIf
    If shipy < -sy
        shipy = shipy + sy*2
        camy = camy - sy*2
    ElseIf shipy >= sy
        shipy = shipy - sy*2
        camy = camy + sy*2
    EndIf
    If respawning
        respawnpos = respawnpos + 1
        If respawnpos = shipw
            dead = False 
            respawning = False 
        EndIf 
    EndIf 
    ; thrust animation
    If fire1
        fire1frame = fire1frame + TimerDone( fire1timer )
        If fire1frame > 6
            fire1frame = 3
        EndIf 
    Else 
        fire1frame = fire1frame - TimerDone( fire1timer )
        If fire1frame < 0
            fire1frame = -1
        EndIf 
    EndIf 
    If fire2
        fire2frame = fire2frame + TimerDone( fire2timer )
        If fire2frame > 6
            fire2frame = 3
        EndIf 
    Else 
        fire2frame = fire2frame - TimerDone( fire2timer )
        If fire2frame < 0
            fire2frame = -1
        EndIf 
    EndIf 
    If fire3
        fire3frame = fire3frame + TimerDone( fire3timer )
        If fire3frame > 3
            fire3frame = 1
        EndIf 
    Else 
        fire3frame = fire3frame - TimerDone( fire3timer )
        If fire3frame < 0
            fire3frame = -1
        EndIf 
    EndIf 

    ; COLLISION

    ; host shell
    If (Not dead) And (Not docked)
        If RectsOverlap( shipx-shipw/2,shipy-shipw/2,shipw,shipw , hostx,hosty,hostw,hosth )
            If vectormodelscollide( shipmodel,shipx,shipy,shipangle , hostcoltopmodel,hostx,hosty,0 ) Or vectormodelscollide( shipmodel,shipx,shipy,shipangle , hostcolbotmodel,hostx,hosty,0 )
                Gosub shipexplode
            EndIf
        EndIf
    EndIf
    ; host doors
    If (Not dead) And (Not docked)
        If RectsOverlap( shipx-shipw/2,shipy-shipw/2,shipw,shipw , hostx,hosty,hostw,hosth )
            If vectormodelscollide( shipmodel,shipx,shipy,shipangle , doorcolmodel,hostx+door1ox,hosty+door1y+door1oy,0 ) Or vectormodelscollide( shipmodel,shipx,shipy,shipangle , doorcolmodel,hostx+door2ox,hosty+door2y+door2oy,0 )
                Gosub shipexplode
            EndIf
        EndIf
    EndIf
    ; proximity: host (broad)
    hostrange = True 
    If (Not dead) And (Not docked)
        If Not RectsOverlap( shipx-shipw/2,shipy-shipw/2,shipw,shipw , (hostx+hostw/2)-(hostw*1.25/2),(hosty+hosth/2)-(hosth*1.25/2),hostw*1.25,hosth*1.25 )
            Gosub closedoors
            hostrange = False 
        Else 
            If shipx < hostx+door1ox Or shipx > hostx+door2ox+doorw
                Gosub opendoors
            EndIf 
        EndIf
    EndIf
    ; proximity: host (precise)
    hostout = True
    If Not dead
        If RectsOverlap( shipx-shipw/2,shipy-shipw/2,shipw,shipw , hostx,hosty,hostw,hosth )
            If vectormodelscollide( shipmodel,shipx,shipy,shipangle , hostproxmodel,hostx,hosty,0 )
                hostout = False
                If messagestate = 1
                    messagestate = 2
                EndIf
            EndIf
        EndIf
    EndIf
    If messagestate = 6
        If hostout
            messagestate = 0
        EndIf 
    EndIf 
    If hostout <> washostout
        If hostout
            MaskFade_In
        Else 
            MaskFade_Out
        EndIf 
        washostout = hostout
    EndIf 
    ; proximity: dock
    candock = False
    If (Not dead); And (Not docked)
        If RectsOverlap( shipx-shipw/2,shipy-shipw/2,shipw,shipw , hostx,hosty,hostw,hosth )
            If vectormodelscollide( shipdockmodel,shipx,shipy,shipangle , hostdocktopmodel,hostx,hosty,0 ) Or vectormodelscollide( shipdockmodel,shipx,shipy,shipangle , hostdockbotmodel,hostx,hosty,0 )
                candock = True
            EndIf
        EndIf
    EndIf

    ; INTERFACE

    ; game speed
    If KeyHit( key_space )
        gameturbo = Not gameturbo
        If gameturbo
            fpsd = 60
        Else 
            fpsd = 30
        EndIf 
    EndIf 
    ; screen capture
    If KeyHit( key_F8 )
        SaveBuffer FrontBuffer() , "capture.bmp"
    EndIf 
    ; camera focus
    If (Not dead) And (Not docked) Or respawning
        camtx = -shipx
        camty = -shipy
        camvx = shipvx
        camvy = shipvy
    ElseIf docked
        camtx = -( shipx + qvx( hostcamrotad*((hostw*9.)/13)/2,hostcamrota ) )
        camty = -( shipy + qvy( hostcamrotad*((hosth*5.)/ 7)/2,hostcamrota ) )
    EndIf 
    If camx <> camtx Or camy <> camty
        camx = camx + Float( camtx - camx ) * camsmooth - camvx
        camy = camy + Float( camty - camy ) * camsmooth - camvy
    EndIf 
    ; frames per second
    frames = frames + 1
    If TimerDone( fpstimer )
        fps = frames
        frames = 0
    EndIf 

    ; EXPLOSIONS

    If dead
        If explodeframe > -1
            If TimerDone( explodetimer )
                explodeframe = explodeframe + 1
                If explodeframe = 9
                    explodeframe = -1
                EndIf
            EndIf
        EndIf
        If shrapnelframe > -1
            If TimerDone( shrapneltimer )
                shrapnelframe = shrapnelframe + 1
                If shrapnelframe = 5
                    shrapnelframe = -1
                EndIf
            EndIf
        EndIf
    EndIf

    ; pre render

    ; HOST SHIP

    SetBuffer ImageBuffer( hostrender1 )
    TileBlock hostpattern , 0,hostpaty
    DrawImage host , 0,0 , 0

    SetBuffer ImageBuffer( hostrender2 )
    Cls
    DrawImage door , door1ox,door1y+door1oy , 0
    DrawImage door , door2ox,door2y+door2oy , 1
    DrawImage hostrender1 , 0,0

    SetBuffer ImageBuffer( hostrender3 )
    Cls 
    MaskImage host , 80,0,160
    DrawImage host , 0,0 , 1
    MaskImage host , 0,0,0
    MaskFade_Draw

    ; PLAYER SHIP

    If Not dead
        shiprender = CopyImage( ship )
        MidHandle shiprender
        SetBuffer ImageBuffer( shiprender )
        If fire1frame > -1
            If turbo And fire2 And KeyDown( key_up )
                DrawImage firehi , shipfire1ox,shipfire1oy , fire1frame
            Else
                DrawImage firelo , shipfire1ox,shipfire1oy , fire1frame
            EndIf
        EndIf
        If fire2frame > -1
            If turbo And fire1 And KeyDown( key_up )
                DrawImage firehi , shipfire2ox,shipfire2oy , fire2frame
            Else
                DrawImage firelo , shipfire2ox,shipfire2oy , fire2frame
            EndIf
        EndIf
        If fire3frame > -1
            DrawImage rfire , shipfire3ox,shipfire3oy , fire3frame
        EndIf
        RotateImage shiprender , shipangle
    Else  ; dead
        If Not respawning
            If shrapnelframe > -1 Or explodeframe > -1
                explodeimage = CreateImage( shipw*2,shipw*2 )
                MidHandle explodeimage
                SetBuffer ImageBuffer( explodeimage )
                If shrapnelframe > -1
                    DrawImage shipshrapnel , shipw,shipw , shrapnelframe
                EndIf
                If explodeframe > -1
                    DrawImage shipexplode , shipw,shipw , explodeframe
                EndIf
                RotateImage explodeimage , shipangle
            Else 
                explodeimage = 0
            EndIf 
        Else  ; respawning
            shiprender = CopyImage( ship )
            MidHandle shiprender
            ResizeImage shiprender , respawnpos,respawnpos
        EndIf 
    EndIf

    ; screen render

    SetBuffer BackBuffer()

    ; BACKGROUND

    ; nebulae / stardust
    TileBlock back , backx,backy
    ; stars
    starfield_display
    ; game zone
    If KeyDown( key_tab )
        Color 128,0,64
        Rect camx+-sx+sx/2,camy+-sy+sy/2 , sx*2,sy*2 , False
    EndIf

    ; HOST SHIP (background)

    DrawImage hostrender2 , camx+hostx+sx/2,camy+hosty+sy/2

    ; PLAYER SHIP (background)

    If Not dead
        DrawImage shiprender , camx+shipx+sx/2,camy+shipy+sy/2
        FreeImage shiprender
        If KeyDown( key_tab )
            Color 128,0,64
            drawvectormodel shipmodel , camx+shipx+sx/2,camy+shipy+sy/2 , shipangle
        EndIf
    Else  ; dead
        If respawning 
            DrawImage shiprender , camx+shipx+sx/2,camy+shipy+sy/2
            FreeImage shiprender 
        EndIf 
    EndIf

    ; HOST SHIP (foreground)

    DrawImage hostrender3 , camx+hostx+sx/2,camy+hosty+sy/2
    If KeyDown( key_tab )
        Color 128,0,64
        drawvectormodel hostcoltopmodel , camx+hostx+sx/2,camy+hosty+sy/2
        drawvectormodel hostcolbotmodel , camx+hostx+sx/2,camy+hosty+sy/2
        drawvectormodel hostproxmodel , camx+hostx+sx/2,camy+hosty+sy/2
        drawvectormodel doorcolmodel , camx+hostx+door1ox+sx/2,camy+hosty+door1y+door1oy+sy/2
        drawvectormodel doorcolmodel , camx+hostx+door2ox+sx/2,camy+hosty+door2y+door2oy+sy/2
        If KeyDown( key_leftshift ) Or KeyDown( key_rightshift )
            drawvectormodelpoints hostdocktopmodel , camx+hostx+sx/2,camy+hosty+sy/2
            drawvectormodelpoints hostdockbotmodel , camx+hostx+sx/2,camy+hosty+sy/2
        EndIf 
    EndIf

    ; PLAYER SHIP (foreground)

    If dead
        If Not respawning
            If explodeimage
                DrawImage explodeimage , camx+shipx+sx/2,camy+shipy+sy/2
                FreeImage explodeimage
            EndIf 
        EndIf 
    EndIf

    ; INTERFACE

    ; guide messages
    messageb = messageb + messagebi
    If messageb <= messagebia Or messageb >= 64-messagebia
        messagebi = -messagebi
    EndIf
    Select messagestate
    Case 1
        SetFont medium
        TextOutLine sx/2,sy/8-8 , "You can enter the space dock in this sector" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
        TextOutLine sx/2,sy/8+8 , "Use <Shift> to toggle thrust intensity" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Case 2
        SetFont medium
        TextOutLine sx/2,sy/8-8 , "Manouver to a free dock bay, and slow down" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
        TextOutLine sx/2,sy/8+8 , "Then press <Enter> to dock" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Case 3
        SetFont medium
        TextOutLine sx/2,sy/8 , "Press <Enter> to release" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Case 4
        SetFont medium
        TextOutLine sx/2,sy/8 , "Press <Enter> to respawn" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Case 5
        SetFont medium
        TextOutLine sx/2,sy/8 , "Press <Enter> to dock" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Case 6
        SetFont medium
        TextOutLine sx/2,sy/8-8 , "Thank you for visiting our space dock" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
        TextOutLine sx/2,sy/8+8 , "Have a good trip" , True,True , messageb+63,messageb+127,messageb+191 , messageb/4+15,messageb*.375+23,messageb/2+31
    Default
    End Select
    ; ship status
    sw = StringWidth( "IN DOCK POSITION" )
    x = sx/4-sw/2-5
    y = sy-14-15
    w = sw+10
    h = 20+10
    RectOutline x,y , w,h , True , 48,48,48 , 96,96,96
    SetFont medium
    TextOutLine sx/4,sy-14 , "SHIP STATUS:" , 1,2 , 255,255,255 , 0,0,0
    If dead
        If respawning
            TextOutLine sx/4,sy-04 , "RESPAWNING" , 1,2 , 255,128,0 , 0,0,0
        Else 
            TextOutLine sx/4,sy-04 , "DESTROYED" , 1,2 , 255,0,0 , 0,0,0
        EndIf 
    ElseIf docked
        If Int shipangle <> 0 And Int shipangle <> 180 And Int shipangle <> 360
            If blink
                TextOutLine sx/4,sy-04 , "DOCKING" , 1,2 , 0,255,255 , 0,0,0
            Else 
                TextOutLine sx/4,sy-04 , "DOCKING" , 1,2 , 0,160,160 , 0,0,0
            EndIf 
        Else 
            TextOutLine sx/4,sy-04 , "DOCKED" , 1,2 , 0,255,255 , 0,0,0
        EndIf 
    ElseIf candock
        If shipv <= dockvmax
            If blink
                TextOutLine sx/4,sy-04 , "IN DOCK POSITION" , 1,2 , 0,255,64 , 0,0,0
            Else 
                TextOutLine sx/4,sy-04 , "IN DOCK POSITION" , 1,2 , 0,160,44 , 0,0,0
            EndIf 
        Else 
            TextOutLine sx/4,sy-04 , "TOO FAST" , 1,2 , 176,255,0 , 0,0,0
        EndIf 
    ElseIf Not hostout
        TextOutLine sx/4,sy-04 , "IN SPACE DOCK" , 1,2 , 128,144,160 , 0,0,0
    Else
        TextOutLine sx/4,sy-04 , "IN SPACE" , 1,2 , 128,144,160 , 0,0,0
    EndIf
    ; ship control status
    If (Not dead) And (Not docked)
        x = sx*3/4-sw/2-5
        y = sy-14-15
        w = sw+10
        h = 20+10
        RectOutline x,y , w,h , True , 48,48,48 , 96,96,96
        SetFont medium
        TextOutLine sx*3/4,sy-14 , "THRUST:" , 1,2 , 255,255,255 , 0,0,0
        If turbo
            TextOutLine sx*3/4,sy-04 , "ENABLED" , 1,2 , 255,192,0 , 0,0,0
        Else
            TextOutLine sx*3/4,sy-04 , "DISABLED" , 1,2 , 160,120,0 , 0,0,0
        EndIf
    EndIf 
    ; debug feedback (basic)
    SetFont small
    TextOutLine sx-2,0 , "VM: "+String_WithCommas( ( TotalVidMem()-AvailVidMem() )/1024 )+"K   FPS: "+fps+"/"+fpsd , 2,False , 64,128,192 , 0,0,0
    ; debug feedback (elaborate)
    If KeyDown( key_tab )
        Color 64,128,192
        SetFont small
        y=0   : Text 0,y , "Location X,Y: "+shipx+","+shipy
        y=y+8            
        y=y+8 : Text 0,y , "Angle Velocity Increase: "+shipanglevi
        y=y+8 : Text 0,y , "Angle Velocity: "+shipanglev
        y=y+8 : Text 0,y , "Angle: "+shipangle
        y=y+8            
        y=y+8 : Text 0,y , "Velocity Increase: "+shipvi
        y=y+8 : Text 0,y , "Velocity,Heading: "+shipv+","+shiph
        y=y+8 : Text 0,y , "Velocity X,Y: "+shipvx+","+shipvy
        y=y+8            
        y=y+8 : Text 0,y , "Thrust turbo: "+String_BooleanText( turbo , "On" )
        y=y+8 : Text 0,y , "Dock in range: "+String_BooleanText( candock , "Yes" )
        y=y+8 : Text 0,y , "Dock speed: "+String_BooleanText( shipv <= dockvmax , "Too fast    Good" )
        y=y+8 : Text 0,y , "Docked: "+String_BooleanText( docked , "Yes" )
        y=y+8            
        y=y+8 : Text 0,y , "Message state: "+messagestate
        y=y+8 : Text 0,y , "Message level: "+messageb
        y=y+8 : Text 0,y , "Message change: "+messagebi
        y=y+8            
        y=y+8 : Text 0,y , "Doors opened: "+String_BooleanText( doorsopen , "Yes" )
        y=y+8 : Text 0,y , "Doors closed: "+String_BooleanText( doorsclosed , "Yes" )
        y=y+8 : Text 0,y , "Doors moving: "+String_BooleanText( doorsmoving , "Yes" )
        y=y+8 : Text 0,y , "Doors motion: "+doorsdir
        y=y+8 : Text 0,y , "Doors in range: "+String_BooleanText( hostrange , "Yes" )
        y=y+8            
        y=y+8 : Text 0,y , "Destroyed: "+String_BooleanText( dead , "Yes" )
        y=y+8 : Text 0,y , "Respawning: "+String_BooleanText( respawning , "Yes" )
    EndIf

    Flip
    If gameturbo
        WaitTimer hiframelimiter
    Else 
        WaitTimer loframelimiter
    EndIf
    Delay 1
Until KeyHit( key_esc )
End

.shipexplode
    explodeframe = 0
    ResetTimer explodetimer
    shrapnelframe = 0
    ResetTimer shrapneltimer
    dead = True
    Gosub closedoors
    messagestate = 4
    turbo = False
Return

.opendoors
    If Not doorsopen
        If doorsmoving
            doorsdir = 1
        Else 
            doorsmoving = True
            doorsdir = 1
        EndIf
    EndIf 
Return 

.closedoors
    If Not doorsclosed
        If doorsmoving
            doorsdir = -1
        Else 
            doorsmoving = True
            doorsdir = -1
        EndIf
    EndIf 
Return 

.openclosedoors
    If doorsmoving
        doorsdir = -doorsdir
    Else 
        If doorsopen
            doorsmoving = True
            doorsdir = -1
        Else  ; closed
            doorsmoving = True
            doorsdir = 1
        EndIf
    EndIf
Return 

Function loadimg( file$ , w,h , f )
    Local img

    img = LoadAnimImage( file , w,h , 0,f )
    If Not img
        RuntimeError "Error loading image: "+file
    EndIf

    Return img
End Function


Function drawrandomblockpattern( ox,oy , w,h , sw,sh , min=0,max=255 , r#=1,g#=1,b#=1 )
    Local x,y
    Local cx,cy
    Local lev
    Local bcx = w/sw-1
    Local bcy = h/sh-1

    y = 0
    For cy = 0 To bcy
        x = 0
        For cx = 0 To bcx
            lev = Rand( min,max )
            Color lev*r,lev*g,lev*b
            Rect x,y , sw,sh
            x = x + sw
        Next
        y = y + sh
    Next

End Function


Function UserSelectWindowMode()
    Local sw=320
    Local sh=200
    Graphics sw,sh , 0,2
    SetBuffer BackBuffer()
    ClsColor 192,224,255
    SetFont LoadFont( "FixedSys" )
    Local w=sw*1.5/4
    Local h=sh/4
    Local y=sh/2-h/2
    Local x1=sw/4-w/2
    Local x2=sw*3./4-w/2
    Local sel=1
    Repeat
        Local mx=MouseX()
        Local my=MouseY()
        Local click=MouseHit(1)
        ; mouse select
        If RectsOverlap( x1,y,w,h , mx,my,1,1 )
            sel=1
            If click
                Exit
            EndIf
        ElseIf RectsOverlap( x2,y,w,h , mx,my,1,1 )
            sel=2
            If click
                Exit
            EndIf
        End If
        ; keyboard select
        If KeyHit( key_Left ) Or KeyHit( key_Right )
            sel=(Not (sel-1))+1
        End If
        If KeyHit(1)
            End
        End If
        If KeyHit( key_Enter ) Or KeyHit( key_Space ) Or KeyHit( key_Return )
            Exit
        End If
        ; box 1
        If sel=1
            Color 64,96,128
        Else
            Color 32,48,64
        End If
        Rect x1,y , w,h
        Color 0,0,0
        Rect x1,y , w,h , False
        If sel=1
            Color 255,255,255
        Else
            Color 128,192,255
        End If
        Text x1+w/2,y+h/2 , "Fullscreen" , True,True
        ; box 2
        If sel=2
            Color 64,96,128
        Else
            Color 32,48,64
        End If
        Rect x2,y , w,h
        Color 0,0,0
        Rect x2,y , w,h , False
        If sel=2
            Color 255,255,255
        Else
            Color 128,192,255
        End If
        Text x2+w/2,y+h/2 , "Windowed" , True,True
        ; show
        Flip
        Cls
        Delay 10
    Forever
    Select sel
        Case 1  ; fullscreen
            Return 1
        Case 2  ; windowed
            Return 3  ; scaled window
        Default  ; autodetect (unused)
            Return 0
    End Select
End Function


;~IDEal Editor Parameters:
;~C#Blitz3D1105