
;-------------------------------------------------------------------------------
;
;   Window Handling (Set window state)
;
;-------------------------------------------------------------------------------

Const SW_HIDE            =  0
Const SW_SHOWNORMAL      =  1
Const SW_NORMAL          =  1
Const SW_SHOWMINIMIZED   =  2
Const SW_SHOWMAXIMIZED   =  3
Const SW_MAXIMIZE        =  3
Const SW_SHOWNOACTIVATE  =  4
Const SW_SHOW            =  5
Const SW_MINIMIZE        =  6
Const SW_SHOWMINNOACTIVE =  7
Const SW_SHOWNA          =  8
Const SW_RESTORE         =  9
Const SW_SHOWDEFAULT     = 10
Const SW_MAX             = 11

;-------------------------------------------------------------------------------

; Change the active window, e.g. Blitz
Function ShowWindow( message = SW_NORMAL )
	window_handle = API_GetActiveWindow()
	API_ShowWindow( window_handle , message )
End Function

;-------------------------------------------------------------------------------
; Example
;
; Graphics 512,384 , 0,3
; Print "untouched" : WaitKey : Cls 
; showwindow sw_maximize
; Print "maximized" : WaitKey : Cls 
; showwindow sw_restore
; Print "restored" : WaitKey : Cls 
; End 
;-------------------------------------------------------------------------------

    ; * Active window functions
    ; User32.decls:
    ;   .lib "USER32.DLL"
    ;   API_ShowWindow( hWnd% , nCmdShow% ) : "ShowWindow"
    ;   API_GetActiveWindow%() : "GetActiveWindow"
    Function MaximizeActiveWindow()
    	API_ShowWindow API_GetActiveWindow() , 3
    End Function
    Function MinimizeActiveWindow()
    	API_ShowWindow API_GetActiveWindow() , 6
    End Function
    Function RestoreActiveWindow()
    	API_ShowWindow API_GetActiveWindow() , 9
    End Function

;-------------------------------------------------------------------------------
;
;   Window dimensions (desktop and active window)
;
;-------------------------------------------------------------------------------

Type struct_RECT
	Field Left
	Field Top
	Field Right
	Field Bottom
End Type

Global struct_RECT.struct_RECT = New struct_RECT

;-------------------------------------------------------------------------------
; userlibs:
;   user32.decls
;     .lib "user32.dll"
;     api_GetDesktopWindow%() : "GetDesktopWindow"
;     api_GetWindowRect%( hwnd% , lpRect* ) : "GetWindowRect"
;-------------------------------------------------------------------------------

Function ActiveWindowWidth()
   api_GetWindowRect api_GetActiveWindow() , struct_RECT
   Return struct_RECT\Right - struct_RECT\Left
End Function 


Function ActiveWindowHeight()
   api_GetWindowRect api_GetActiveWindow() , struct_RECT
   Return struct_RECT\Bottom - struct_RECT\Top
End Function 


Function DesktopWidth()
   api_GetWindowRect api_GetDesktopWindow() , struct_RECT
   Return struct_RECT\Right - struct_RECT\Left
End Function 


Function DesktopHeight()
   api_GetWindowRect api_GetDesktopWindow() , struct_RECT
   Return struct_RECT\Bottom - struct_RECT\Top
End Function 


;Function DesktopWidth()  ; by EPS
;;======================================== 
;; Ermittle Windows Desktopbreite 
;;======================================== 
;   Local struct_rect% = CreateBank(16) 
;
;   api_GetWindowRect(api_GetDesktopWindow(),struct_rect) 
;   Local res = PeekInt(struct_rect,8) 
;   FreeBank struct_rect 
;
;   Return res 
;End Function 
;
;
;Function DesktopHeight()  ; by EPS
;;======================================== 
;; Ermittle Windows Desktophhe 
;;======================================== 
;   Local struct_rect% = CreateBank(16) 
;
;   api_GetWindowRect(api_GetDesktopWindow(),struct_rect) 
;   Local res = PeekInt(struct_rect,12) 
;   FreeBank struct_rect 
;
;   Return res 
;End Function 

;-------------------------------------------------------------------------------

Function WindowDimensions_Demo()
    Graphics 160,120 , 0,3
    SetBuffer BackBuffer()
    Repeat 
        Cls 
        Text 0,0  , "Canvas: "+GraphicsWidth()+"x"+GraphicsHeight()
        Text 0,10 , "Window: "+ActiveWindowWidth()+"x"+ActiveWindowHeight()
        Text 0,20 , "Desktop: "+DesktopWidth()+"x"+DesktopHeight()
        Flip 
    Until KeyHit( 1 )
    End 
End Function

;windowdimensions_demo
